with text_io;                            use text_io;
with Communications_with_User;           use Communications_with_User;
with Standard_Complex_Numbers;           use Standard_Complex_Numbers;
with Standard_Complex_Solutions;         use Standard_Complex_Solutions;
with Standard_Complex_Poly_Systems;      use Standard_Complex_Poly_Systems;
with Standard_Complex_Poly_Systems_io;   use Standard_Complex_Poly_Systems_io;
with Drivers_for_Poly_Continuation;      use Drivers_for_Poly_Continuation;

procedure ts_poco is

-- DESCRIPTION :
--   Calls the driver for polynomial continuation.

  file : file_type;
  lp : Link_to_Poly_Sys;
  sols : Solution_List;
  target : Complex_Number;

begin
  new_line;
  get(lp);
  new_line;
  put_line("Reading the name of the output file.");
  Read_Name_and_Create_File(file);
  new_line;
  Driver_for_Polynomial_Continuation(file,lp.all,sols,target);
end ts_poco;

