with integer_io;                         use integer_io;

package body Generic_VecMats_io is

  use Matrices,Matrices_io;

  procedure get ( n : in natural; v : in out VecMat ) is
  begin
    get(Standard_Input,n,v);
  end get;

  procedure get ( file : in file_type; n : in natural; v : in out VecMat ) is

    n1,n2 : natural;

  begin
    for i in v'range loop
      get(file,n1);
      get(file,n2);
      v(i) := new Matrix(1..n1,1..n2);
      get(file,v(i).all);
    end loop;
  end get;

  procedure get ( n,n1,n2 : in natural; v : in out Link_to_VecMat ) is
  begin
    get(Standard_Input,n,n1,n2,v);
  end get;

  procedure get ( file : in file_type; n,n1,n2 : in natural;
                  v : in out Link_to_VecMat ) is
  begin
    v := new VecMat(1..n);
    for i in 1..n loop
      v(i) := new Matrix(1..n1,1..n2);
      get(file,v(i).all);
    end loop;
  end get;

  procedure put ( v : in VecMat ) is
  begin
    put(Standard_Output,v);
  end put;

  procedure put ( file : in file_type; v : in VecMat ) is
  begin
    for i in v'range loop
      put(file,v(i).all); new_line(file);
    end loop;
  end put;

  procedure put ( v : in Link_to_VecMat ) is
  begin
    put(Standard_Output,v);
  end put;

  procedure put ( file : in file_type; v : in Link_to_VecMat ) is
  begin
    if v /= null
     then put(file,v.all);
    end if;
  end put;

  procedure put ( v : in VecMat; dp : in natural ) is
  begin
    put(Standard_Output,v,dp);
  end put;

  procedure put ( file : in file_type; v : in VecMat; dp : in natural ) is
  begin
    for i in v'range loop
      put(file,v(i).all,dp); new_line(file);
    end loop;
  end put;

  procedure put ( v : in Link_to_VecMat; dp : in natural ) is
  begin
    put(Standard_Output,v,dp);
  end put;

  procedure put ( file : in file_type;
                  v : in Link_to_VecMat; dp : in natural ) is
  begin
    if v /= null
     then put(file,v.all,dp);
    end if;
  end put;

end Generic_VecMats_io;
