with Multprec_Complex_Number_Tools;      use Multprec_Complex_Number_Tools;

package body Multprec_Complex_Vector_Tools is

  function Create ( v : Standard_Complex_Vectors.Vector )
                  return Multprec_Complex_Vectors.Vector is

    res : Multprec_Complex_Vectors.Vector(v'range);

  begin
    for i in v'range loop
      res(i) := Create(v(i));
    end loop;
    return res;
  end Create;

  procedure Set_Size ( v : in out Multprec_Complex_Vectors.Vector;
                       size : in natural ) is
  begin
    for i in v'range loop
      Set_Size(v(i),size);
    end loop;
  end Set_Size;

end Multprec_Complex_Vector_Tools;
