with Multprec_Integer_Matrices;
with Multprec_Floating_Matrices;
with Multprec_Complex_Matrices;

package Multprec_Random_Matrices is

-- DESCRIPTION :
--   Offers routines to generate random matrices of multi-precision numbers.

  function Random_Matrix ( n,m,sz : natural )
                         return Multprec_Integer_Matrices.Matrix;

  -- DESCRIPTION :
  --   Returns a matrix of range 1..n,1..m with entries of size sz.

  function Random_Matrix ( n,m,sz : natural )
                         return Multprec_Floating_Matrices.Matrix;

  -- DESCRIPTION :
  --   Returns a matrix of range 1..n,1..m with entries of size sz.

  function Random_Matrix ( n,m,sz : natural )
                         return Multprec_Complex_Matrices.Matrix;

  -- DESCRIPTION :
  --   Returns a matrix of range 1..n,1..m with entries of size sz.

end Multprec_Random_Matrices;
