with Multprec_Floating_Numbers;          use Multprec_Floating_Numbers;
with Multprec_Floating_Numbers_io;       use Multprec_Floating_Numbers_io;

package body Multprec_Complex_Numbers_io is

  procedure get ( x : in out Complex_Number ) is
  begin
    get(Standard_Input,x);
  end get;

  procedure get ( file : in file_type; x : in out Complex_Number ) is

    xre,xim : Floating_Number;

  begin
    get(file,xre);
	get(file,xim);
    x := Create(xre,xim);
    Clear(xre); Clear(xim);
  end get;

  procedure put ( x : in Complex_Number ) is
  begin
    put(Standard_Output,x);
  end put;

  procedure put ( file : in file_type; x : in Complex_Number ) is
  begin
    put(file,REAL_PART(x));
    put(file,"  ");
    put(file,IMAG_PART(x));
  end put;

  procedure put ( c : in Complex_Number; fore,aft,exp : in natural ) is
  begin
    put(Standard_Output,c,fore,aft,exp);
  end put;

  procedure put ( file : in file_type;
                  c : in Complex_Number; fore,aft,exp : in natural ) is
  begin
    put(file,REAL_PART(c),fore,aft,exp);
    put(file,"  ");
    put(file,IMAG_PART(c),fore,aft,exp);
  end put;

  procedure put ( c : in Complex_Number; dp : in natural ) is
  begin
    put(c,dp,dp,dp);
  end put;

  procedure put ( file : in file_type;
                  c : in Complex_Number; dp : in natural ) is
  begin
    put(file,c,dp,dp,dp);
  end put;                                       

end Multprec_Complex_Numbers_io;
