with text_io,integer_io;                 use text_io,integer_io;
with Communications_with_User;           use Communications_with_User;
with Lists_of_Integer_Vectors;           use Lists_of_Integer_Vectors;
with Lists_of_Integer_Vectors_io;        use Lists_of_Integer_Vectors_io;
with Triangulations,Triangulations_io;   use Triangulations,Triangulations_io;
with Dynamic_Triangulations;             use Dynamic_Triangulations;

procedure ts_dyntri is

-- DESCRIPTION :
--   Test the creation of a regular triangulation by dynamic lifting.

  file : file_type;
  n,d,vol : natural;
  l,lifted,lifted_last : List;
  t : Triangulation;

begin
  new_line;
  put_line("Testing the creation of a regular triangulation");
  new_line;
  put_line("Reading the name of the output file.");
  Read_Name_and_Create_File(file);
  put("Give d, the dimension : "); get(d);
  put("Give n, the number of points : "); get(n);
  put("Give "); put(n,1); put(" vectors of length "); put(d,1);
  put_line(" :");
  get(d,n,l);
  put(file,"n = "); put(file,n,1);
  put(file,"  d = "); put(file,d,1); new_line(file);
  put_line(file,"The points : "); put(file,l);
  Dynamic_Lifting(l,true,false,0,lifted,lifted_last,t);
  put_line(file,"The lifted points : "); put(file,lifted);
  put_line(file,"The triangulation : "); put(file,d,t,vol);
  put(file,"The volume : "); put(file,vol,1); new_line(file);
end ts_dyntri;
